require "import"
import "android.app.*"
import "android.os.*"
import "android.widget.*"
import "android.view.*"
import "android.text.Html"
import "android.os.Build"
import "android.content.pm.ActivityInfo"
require "loadbitmap"
require "loadlayout"
import "android.graphics.Color"
cjson = require "cjson"

appData = {}
loadfile(activity.getLuaDir() .. "/init.lua", "bt", appData)()


function getFile(file_name)
    local f = assert(io.open(file_name, 'r'))
    local string = f:read("*all")
    f:close()
    return string
end

local jsonConfig = getFile(activity.getLuaDir() .. "/config.json")
config = cjson.decode(jsonConfig)

--activity.setTitle('AndroLua+')
--activity.setTheme(android.R.style.Theme_Holo_Light)

local ic_menu_base64 = [[iVBORw0KGgoAAAANSUhEUgAAAEgAAABICAYAAABV7bNHAAAAAXNSR0IArs4c6QAAAARzQklUCAgI
CHwIZIgAAAEFSURBVHic7dhRTsMwEEXRhhV0h3hJ7CxhRZePkoKiyh4EzSvNPd+WMhpNrPE7nSRJ
kiRJhwQ0YObLDLym64oDzpvGbM3AOV1nDLB0mnNtUrrOiM/fqqql691dcXriUzSlPgzwk/PTNEVq
fUl89D9JNuj9Tmf/VLJBb3c6+zyKF/WSrjOGy6LYa9LCkRfFFZedaNk0pqXrkiRJv4aJ4m2YKPYV
nxomigUtXe/uitMTnyITxQETxQETxQETxUdWvKhNFHvN4ciL4goTRUmSnhUmirdhothXfGqYKBa0
dL27K05PfIpMFAdMFAdMFAdMFB9Z8aI2Uew1hyMviitMFCVJkiRJ33wAJlOCzHUm3wcAAAAASUVO
RK5CYII=]]

function base642Bitmap(base64)
    local Base64 = luajava.bindClass "android.util.Base64"
    local BitmapFactory = luajava.bindClass "android.graphics.BitmapFactory"
    base64 = String(base64)
    bitmap = nil;
    xpcall(function()
        bitmapArray = Base64.decode(base64, Base64.DEFAULT);
        bitmap = BitmapFactory.decodeByteArray(bitmapArray, 0, #bitmapArray);
    end, function(e)
        print(e)
    end)
    return bitmap;
end



local layout = {
    LinearLayout,
    Orientation = 1,
    BackgroundColor = 0xffffffff,
    layout_width = "match",
    layout_height = "match",

        {
            LinearLayout,
            layout_width = "fill",
            layout_height = "56dp",
            id = "appbar",
            Orientation = 0,
            backgroundColor = config.actionbar.color.background,
            {
                TextView,
                id = "titleTvw",
                layout_width = 0,
                layout_height = "wrap",
                textSize = "20sp",
                layout_weight = 1,
                layout_gravity = "center",
                textColor = "#FFFFFF",
                layout_marginLeft = "24dp"
            },
            {
                ImageView,
                id = "menuIvw",
                imageBitmap = base642Bitmap(ic_menu_base64),
                layout_gravity = "center",
                layout_width = "56dp",
                layout_height = "56dp",
                padding = "16dp"
            }
        },

    {
        LuaWebView,
        id = "webView",
        layout_width = "match",
        layout_height = 0,
        layout_weight = 1,
    }
}

activity.setContentView(loadlayout(layout))
--activity.setSupportActionBar(toolbar)
activity.getWindow().setStatusBarColor(Color.parseColor(config.actionbar.color.background))

if config.landscape then
    activity.setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_LANDSCAPE);
end


if config.actionbar.display == false then
    appbar.visibility = 8
    import "android.view.WindowManager"
    activity.getWindow().setFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN, WindowManager.LayoutParams.FLAG_FULLSCREEN);
end


if appData["appname"] ~= nil then
    titleTvw.text = appData["appname"]
end

if config.actionbar.progress_display == false then
    webView.setProgressBarEnabled(false)
end

webView.loadUrl(config.web_url)

menuIvw.onClick=function(v)
    local popmenu=PopupMenu(activity,v)
    local menu=popmenu.menu
    menu.add("退出应用").onMenuItemClick=function(a)
        activity.finish()
    end
    popmenu.show()
end


